  ; EEPROM (  256 ).
;     Temp    ,
;    -  .
;   - 27 
;  (       EEPROM ).
EEPROM_Read:
	push	Tmp		
	in	Tmp, SREG	;    .
	push	Tmp		
	cli			;      .

	sbic	EECR, EEWE	; 
	rjmp	PC-1		; .

	out	EEARL, Temp	;     EEPROM.
	clr	Temp		;   256  EEPROM.
	out	EEARH, Temp
		
	sbi	EECR, EERE	; .
	in	Temp, EEDR	;    Temp.
		
	pop	Tmp		; 
	out	SREG, Tmp	; .
	pop	Tmp
	ret

;*****************************************************************************
  ;  EEPROM   Tmp     
;  EEPROM,      Temp.
;      .
; ,       eeprom ,
;   .
;  - 62 .
EepromWriteIfDifferent:
	push	R2
	in	R2, SREG
	push	R2
	cli

	sbic	EECR, EEWE	;    eeprom,
	rjmp	Exit_EepromWriteIfDifferent;   .
	in	R2, SPMCR	;  
	sbrc	R2, SPMEN	;  ,
	rjmp	Exit_EepromWriteIfDifferent;   .

	mov	R2, Temp	;    eeprom.
	rcall	EEPROM_Read		
	cp	Temp, Tmp	;    .
	breq	Exit_EepromWriteIfDifferent;  ,    .
	
	mov	Temp, R2	;   eeprom.
	out	EEARL, Temp	;     EEPROM.
	clr	Temp		;   256  EEPROM.
	out	EEARH, Temp
	out	EEDR, Tmp	;     EEDR.

	sbi	EECR, EEMWE	; 
	sbi	EECR, EEWE	; EEPROM.

Exit_EepromWriteIfDifferent:
	pop	R2
	out	SREG, R2
	pop	R2
	ret
